﻿<?php

/*********************************************************************************************
# SOBI2 To JomSocial Activity Stream (A SOBI2 plugin)
# project home: 	sourceforge.net
# version: 			0.1 2010-09-17
# author: 			Georgi Serbezov
# copyright: 		(C) 2010 Georgi Serbezov
# license: 			GNU/GPL
# license text: 	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# 			
# credits:			I just adapted and glued things up.
#					Almost every line of code is taken from forum posts and all
#					credit goes to the original code authors, especially:
#						- James for this post and code:
#					http://www.sigsiu.net/forum/index.php/topic,23271.msg78729.html#msg78729
#						- Mano for the code of his excellent GNU GPL-ed 
#						  Sobi2 Entry Navigation Plugin
#					http://www.webmano.hu/sobi2-entry-navigation-plugin.html
********************************************************************************************/
 
class sobi2jsas {

	function sobi2jsas() {
		error_reporting(E_NOTICE | E_ERROR);
	}
	
// $action is set by the calling function depending on the event type
		
	function addToJSActivityStream($sobi2Id, $action) {

		jimport('joomla.filesystem.file');	
		$jsCoreFile = JPATH_BASE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php';	
		if ( !file_exists($jsCoreFile))
			{exit;}		
		else 			
			{ require_once($jsCoreFile); }		
				
		$daSobi = new sobi2( $sobi2Id ); 

		$what = '';		
		switch ($action) {
	    case "save":
	        $what = _S2JSAS_ADDED_NEW_ENTRY;
	        break;
	    case "update":
	        $what = _S2JSAS_UPDATED_ENTRY;
	        break;
	    case "unpublish":
	        $what = _S2JSAS_UNPUBLISHED_ENTRY;
	        break;
		case "delete":
	        $what = _S2JSAS_DELETED_ENTRY;
	        break;
		}		
		
		$catid = $daSobi->params['def_cid'];
		$catname = $daSobi->myCategories[$catid];
		$Itemid = JRequest::getVar('Itemid');
		$href = "index.php?option=com_sobi2&amp;sobi2Task=sobi2Details&amp;catid={$catid}&amp;sobi2Id={$daSobi->id}&amp;Itemid={$Itemid}";
		$cathref = "index.php?option=com_sobi2&amp;catid={$catid}&amp;Itemid={$Itemid}";

		$activity = new stdClass();		
		$activity->cmd = 'wall.write';         
		$activity->actor = JFactory::getUser()->id;
		$activity->target = 0; 			
		if ($action == "delete") {
			$activity->title = JText::_('{actor} '.$what);
		}	
		elseif ($action == "unpublish") {
			$activity->title = JText::_('{actor} '.$what.' '.$daSobi->title.' '. _S2JSAS_IN_CATEGORY.' <a href="'.$cathref.'">'.$catname.'</a>');
		}
		else {
			$activity->title = JText::_('{actor} '.$what.' <a href="'.$href.'">'.$daSobi->title.'</a> '. _S2JSAS_IN_CATEGORY.' <a href="'.$cathref.'">'.$catname.'</a>');
		}
		
		$activity->content = '';        
		$activity->app = 'wall';        
		$activity->cid = 0;      

		CFactory::load('libraries', 'activities');        
		CActivityStream::add($activity);
				return null;
}


//*****************************************************************************
//*****************************************************************************
// Took me a day to find out this:
// key events passed by Sobi2 to its plugins:
// * sobi2task *	...activates...>	* plugin method*
//    saveSobi 	.........................>	  "save"
//	 updateSobi	 ........................>	 "update"	
//	unpublishSobi  ....................>   "onUnpublish"
//    deleteSobi  .......................>   "onDelete"
//      sobi2  ........................>   "onCreateSobiObj"	
//     MORE   ...........................>  see sobi2.class.php (tip: find "S2")
// I hope it saves someone else's day.
//******************************************************************************

	function onDelete($input,$sobi2Id){
		$this->addToJSActivityStream($input, "delete");
				return null;
}

	function onUnpublish($input,$sobi2Id){
		$this->addToJSActivityStream($input, "unpublish");
				return null;
}

	function save($input,$sobi2Id) {
		$this->addToJSActivityStream($sobi2Id, "save");
				return null;
}

	function update($input,$sobi2Id){
		$this->addToJSActivityStream($sobi2Id, "update");
				return null;
}
//*****************************************************************************
// NOTE: delete and unpublish return null as $sobi2Id => no sobi object can be
// created using it. Comes out that the entry id is returned by $input which is
// used here in the case of a unpublish event (the only difference in displaying
// the activity being the lack of a link to the entry, since it is unpublished
// and won't be displayed anyway.
// The "delete" scenario I find impossible to handle though. Obviously SOBI2 
// deletes the DB table row and then only triggers the plugins' onDelete event
// handler which leaves the handler with nothing to handle - the entry (with the
// otherways passed by $input entry id) does not exist anymore so no info about
// it can be retrieved.

}
?>